/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.jiuqi.util.JqLib
 *  com.jiuqi.util.SortedList
 *  com.jiuqi.util.StringUtils
 */
package com.jiuqi.util.hardware;

import com.jiuqi.util.JqLib;
import com.jiuqi.util.SortedList;
import com.jiuqi.util.StringUtils;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public final class HardwareUtil {
    private static final int CODE_SEED = 151;

    public static final String getMachineCode(String softFlag) throws Exception {
        String code = String.valueOf(softFlag) + "@" + HardwareUtil.getMacAddress();
        MessageDigest md5 = MessageDigest.getInstance("md5");
        byte[] data = md5.digest(code.getBytes());
        data = HardwareUtil.encodeData(data);
        String md5Data = JqLib.bytesToHexString((byte[])data);
        String machineCode = "";
        int i = 0;
        i = 0;
        while (i < md5Data.length() - 4) {
            machineCode = String.valueOf(machineCode) + md5Data.substring(i, i + 4) + "-";
            i += 4;
        }
        machineCode = String.valueOf(machineCode) + md5Data.substring(i, md5Data.length());
        return machineCode;
    }

    public static final byte[] getMachineSign(String category) {
        MessageDigest md5;
        byte[] codeBytes;
        String macAddr;
        try {
            macAddr = HardwareUtil.getMacAddress();
            if (StringUtils.isEmpty((String)macAddr)) {
                return null;
            }
        }
        catch (Exception exception) {
            return null;
        }
        String code = String.valueOf(category) + "@" + macAddr;
        try {
            codeBytes = code.getBytes("UTF-8");
        }
        catch (UnsupportedEncodingException unsupportedEncodingException) {
            codeBytes = code.getBytes();
        }
        try {
            md5 = MessageDigest.getInstance("MD5");
        }
        catch (NoSuchAlgorithmException noSuchAlgorithmException) {
            return null;
        }
        byte[] data = md5.digest(codeBytes);
        return HardwareUtil.encodeData(data);
    }

    private static byte[] encodeData(byte[] data) {
        if (data == null) {
            return null;
        }
        int newSize = data.length / 2;
        byte[] result = new byte[newSize];
        int i = 0;
        while (i < newSize) {
            byte a = data[i * 2];
            byte b = data[i * 2 + 1];
            result[i] = (byte)(a ^ 151 + b ^ 0xFFFFFF68);
            ++i;
        }
        return result;
    }

    public static String getMacAddress() throws Exception {
        String os = System.getProperty("os.name");
        if (os.startsWith("Windows")) {
            return HardwareUtil.getWindowsMacAddresses();
        }
        if (os.startsWith("Linux")) {
            return HardwareUtil.getLinuxMacAddresses();
        }
        if (os.startsWith("HP-UX")) {
            return HardwareUtil.getHPUXMacAddresses();
        }
        return "";
    }

    private static String getWindowsMacAddresses() throws IOException {
        String ipCommandResponse = HardwareUtil.windowsRunIpConfigCommand();
        return HardwareUtil.windowsParseMacAddress(ipCommandResponse);
    }

    private static String windowsRunIpConfigCommand() throws IOException {
        Process p = Runtime.getRuntime().exec("ipconfig /all");
        return HardwareUtil.readInputText(p);
    }

    private static String readInputText(Process p) throws IOException {
        String line;
        StringBuffer buffer = new StringBuffer();
        BufferedReader reader = new BufferedReader(new InputStreamReader(p.getInputStream()));
        while ((line = reader.readLine()) != null) {
            buffer.append(line);
            buffer.append(StringUtils.LINE_SEPARATOR);
        }
        return buffer.toString();
    }

    private static String windowsParseMacAddress(String ipConfigResponse) {
        StringTokenizer stringTokenizer = new StringTokenizer(ipConfigResponse, "\n");
        SortedList buffer = new SortedList();
        while (stringTokenizer.hasMoreTokens()) {
            String macAddr;
            String line = stringTokenizer.nextToken().trim();
            if (!line.startsWith("Physical") && !line.startsWith("物理地址")) continue;
            int p = line.lastIndexOf(58);
            String string = macAddr = p + 1 >= line.length() ? null : line.substring(p + 1).trim();
            if (StringUtils.isEmpty(macAddr) || buffer.contains((Object)macAddr)) continue;
            buffer.add((Object)macAddr);
        }
        return HardwareUtil.catMacAddrs((List)buffer);
    }

    private static String catMacAddrs(List buffer) {
        if (buffer.size() == 0) {
            return null;
        }
        StringBuffer result = new StringBuffer((String)buffer.get(0));
        int i = 1;
        while (i < buffer.size()) {
            result.append(';').append(((String)buffer.get(i)).toUpperCase());
            ++i;
        }
        return result.toString();
    }

    private static String getLinuxMacAddresses() throws Exception {
        String ifCommandResponse = HardwareUtil.linuxRunIfConfigCommand();
        return HardwareUtil.linuxParseMacAddress(ifCommandResponse);
    }

    private static String linuxRunIfConfigCommand() throws IOException {
        Process p = Runtime.getRuntime().exec("ifconfig");
        return HardwareUtil.readInputText(p);
    }

    private static String linuxParseMacAddress(String ifCommandResponse) {
        StringTokenizer stringTokenizer = new StringTokenizer(ifCommandResponse, "\n");
        SortedList buffer = new SortedList();
        while (stringTokenizer.hasMoreTokens()) {
            String macAddr;
            String line = stringTokenizer.nextToken();
            int macPos = line.indexOf("HWaddr");
            if (macPos == -1 || (macAddr = line.substring(macPos + 1).trim()).length() != 17 || buffer.contains((Object)macAddr)) continue;
            buffer.add((Object)macAddr);
        }
        return HardwareUtil.catMacAddrs((List)buffer);
    }

    private static String getHPUXMacAddresses() throws IOException {
        String lanscanCommandResponse = HardwareUtil.hpUXRunLanscanCommmand();
        return HardwareUtil.hpUXParseMacAddress(lanscanCommandResponse);
    }

    private static String hpUXRunLanscanCommmand() throws IOException {
        Process p = Runtime.getRuntime().exec("lanscan");
        return HardwareUtil.readInputText(p);
    }

    private static String hpUXParseMacAddress(String lanscanCommandResponse) {
        StringTokenizer stringTokenizer = new StringTokenizer(lanscanCommandResponse, "\n");
        ArrayList<String> buffer = new ArrayList<String>();
        while (stringTokenizer.hasMoreTokens()) {
            String macAddr;
            String line = stringTokenizer.nextToken().trim();
            int index = line.indexOf("0x");
            if (index == -1 || buffer.contains(macAddr = line.substring(index + 2, index + 2 + 12))) continue;
            buffer.add(macAddr);
        }
        return HardwareUtil.catMacAddrs(buffer);
    }
}

